/* This function is called by Windows 95 and is passed 
   messages from the message queue.  */
LRESULT CALLBACK WindowFunc(HWND hwnd, UINT message,
                            WPARAM wParam, LPARAM lParam)
{
  HDC hdc;
  PAINTSTRUCT paintstruct;
  
  switch(message) {
    case WM_CHAR: /* process keystroke */
      hdc = GetDC(hwnd); /* get device context */
      TextOut(hdc, 1, 1, "  ", 2); /* erase old character */
      sprintf(str, "%c", (char) wParam); /* stringize character */
      TextOut(hdc, 1, 1, str, strlen(str)); /* output char */
      ReleaseDC(hwnd, hdc); /* release device context */
      break;      
    case WM_PAINT: /* process a repaint request */
      hdc = BeginPaint(hwnd, &paintstruct); /* get DC */
      TextOut(hdc, 1, 1, str, strlen(str)); /* output string*/
      EndPaint(hwnd, &paintstruct); /* release DC */
      break;
    case WM_DESTROY: /* terminate the program */
      PostQuitMessage(0);
      break;
    default:
       /* Let Windows 95 process any messages not specified in
          the preceding switch statement. */
      return DefWindowProc(hwnd, message, wParam, lParam);
  }
  return 0;
}
