#include <windows.h>
#include "WM_Timer.h"
#include <stdio.h>
#include <time.h>

#if defined (win32)
   #define IS_WIN32 TRUE
#else
   #define IS_WIN32 FALSE
#endif

HINSTANCE hInst;        // current instance
LPCTSTR lpszAppName = "WMPAINT";
LPCTSTR lpszTitle =   "WM_Paint";
BOOL RegisterWin95(CONST WNDCLASS* lpwc);
char str[80] = ""; /* holds output string */


int X = 1, Y = 1; /* screen location */

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
 {
   MSG msg;
   HWND hWnd;
   WNDCLASS wc;

   wc.style          = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc    = (WNDPROC)WndProc;
   wc.cbClsExtra     = 0;
   wc.cbWndExtra     = 0;
   wc.hInstance      = 0;
   wc.hIcon          = LoadIcon(hInstance, lpszAppName);
   wc.hCursor        = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground  = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName   = lpszAppName;
   wc.lpszClassName  = lpszAppName;

   if(!RegisterWin95(&wc))
      return false;
   hInst = hInstance;
   hWnd = CreateWindow (lpszAppName,
                        lpszTitle,
                        WS_OVERLAPPEDWINDOW,
                        CW_USEDEFAULT, 0,
                        CW_USEDEFAULT, 0,
                        NULL,
                        NULL,
                        hInstance,
                        NULL
                       );
   if(!hWnd)
      return false;
   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   /* start a timer -- interrupt once per second */
   SetTimer(hWnd, 1, 1000, NULL);
   
   while(GetMessage(&msg, NULL, 0,0))
    {
      TranslateMessage(&msg);
      DispatchMessage(&msg);
    }
   
   KillTimer(hWnd, 1); /* stop the timer */
   return(msg.wParam);
 }

BOOL RegisterWin95(CONST WNDCLASS* lpwc)
 {
   WNDCLASSEX wcex;

   wcex.style           = lpwc->style;
   wcex.lpfnWndProc     = lpwc->lpfnWndProc;
   wcex.cbClsExtra      = lpwc->cbClsExtra;
   wcex.cbWndExtra      = lpwc->cbWndExtra;
   wcex.hInstance       = lpwc->hInstance;
   wcex.hIcon           = lpwc->hIcon;
   wcex.hCursor         = lpwc->hCursor;
   wcex.hbrBackground   = lpwc->hbrBackground;
   wcex.lpszMenuName    = lpwc->lpszMenuName;
   wcex.lpszClassName   = lpwc->lpszClassName;
   wcex.cbSize          = sizeof(WNDCLASSEX);
   wcex.hIconSm         = LoadIcon(wcex.hInstance, "SMALL");
   return RegisterClassEx(&wcex);
 }

LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
 {
   HDC hdc;
   PAINTSTRUCT paintstruct;
   time_t t;
   struct tm *newtime;

   switch(uMsg)
    {
	  case WM_PAINT: /* process a repaint request */
		hdc = BeginPaint(hWnd, &paintstruct); /* get DC */
		TextOut(hdc, X, Y, str, strlen(str)); /* output string */
		EndPaint(hWnd, &paintstruct); /* release DC */
		break;
      case WM_TIMER: /* timer went off */
		/* get the new time */
		t = time(NULL);
		newtime = localtime(&t);

		/* display the new time */
		strcpy(str, asctime(newtime));
		str[strlen(str)-1] = '\0'; /* remove /r/n */
		InvalidateRect(hWnd, NULL, 0); /* update screen */
		break;  
	  case WM_DESTROY :
		 PostQuitMessage(0);
         break;
      default:
         return (DefWindowProc(hWnd, uMsg, wParam, lParam));
    }
   return(0L);
 }

