
#include <windows.h>  
#include "CheckBox1.h" 


#if defined (WIN32)
	#define IS_WIN32 TRUE
#else
	#define IS_WIN32 FALSE
#endif

#define IS_NT      IS_WIN32 && (BOOL)(GetVersion() < 0x80000000)
#define IS_WIN32S  IS_WIN32 && (BOOL)(!(IS_NT) && (LOBYTE(LOWORD(GetVersion()))<4))
#define IS_WIN95   (BOOL)(!(IS_NT) && !(IS_WIN32S)) && IS_WIN32

HINSTANCE hInst;          // current instance
int status1=0, status2=0; /* holds status of check boxes */

LPCTSTR lpszAppName  = "DlgBox";
LPCTSTR lpszTitle    = "Chap08"; 

BOOL RegisterWin95( CONST WNDCLASS* lpwc );

int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                      LPTSTR lpCmdLine, int nCmdShow)
{
   MSG      msg;
   HWND     hWnd; 
   WNDCLASS wc;

   // Register the main application window class.
   //............................................
   wc.style         = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc   = (WNDPROC)WndProc;       
   wc.cbClsExtra    = 0;                      
   wc.cbWndExtra    = 0;                      
   wc.hInstance     = hInstance;              
   wc.hIcon         = LoadIcon( hInstance, lpszAppName ); 
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName  = lpszAppName;              
   wc.lpszClassName = lpszAppName;              

   if ( IS_WIN95 )
   {
      if ( !RegisterWin95( &wc ) )
         return( FALSE );
   }
   else if ( !RegisterClass( &wc ) )
      return( FALSE );

   hInst = hInstance; 

   // Create the main application window.
   //....................................
   hWnd = CreateWindow( lpszAppName, 
                        lpszTitle,    
                        WS_OVERLAPPEDWINDOW, 
                        CW_USEDEFAULT, 0, 
                        CW_USEDEFAULT, 0,  
                        NULL,              
                        NULL,              
                        hInstance,         
                        NULL               
                      );

   if ( !hWnd ) 
      return( FALSE );

   ShowWindow( hWnd, nCmdShow ); 
   UpdateWindow( hWnd );         

   while( GetMessage( &msg, NULL, 0, 0) )   
   {
      TranslateMessage( &msg ); 
      DispatchMessage( &msg );  
   }

   return( msg.wParam ); 
}


BOOL RegisterWin95( CONST WNDCLASS* lpwc )
{
   WNDCLASSEX wcex;

   wcex.style         = lpwc->style;
   wcex.lpfnWndProc   = lpwc->lpfnWndProc;
   wcex.cbClsExtra    = lpwc->cbClsExtra;
   wcex.cbWndExtra    = lpwc->cbWndExtra;
   wcex.hInstance     = lpwc->hInstance;
   wcex.hIcon         = lpwc->hIcon;
   wcex.hCursor       = lpwc->hCursor;
   wcex.hbrBackground = lpwc->hbrBackground;
   wcex.lpszMenuName  = lpwc->lpszMenuName;
   wcex.lpszClassName = lpwc->lpszClassName;

   // Added elements for Windows 95.
   //...............................
   wcex.cbSize = sizeof(WNDCLASSEX);
   wcex.hIconSm = LoadIcon(wcex.hInstance, "SMALL");
			
   return RegisterClassEx( &wcex );
}


LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
   char str[140];
   switch( uMsg )
   {
      case WM_COMMAND :
              switch( LOWORD( wParam ) )
              {
                 case IDM_TEST :
                        DialogBox( hInst, "TestDialog", hWnd,
                                   (DLGPROC)TestDlgProc );
                        break;
				case ID_STATUS: /* show check box status */
                   if(status1) 
					   strcpy(str, "Checkbox 1 is checked\n");
                   else 
					   strcpy(str, "Checkbox 1 is not checked\n");
                   if(status2) 
					   strcat(str, "Checkbox 2 is checked");
                   else 
					   strcat(str, "Checkbox 2 is not checked");
                   MessageBox(hWnd, str, "Status", MB_OK);
                   break;

                 case IDM_EXIT :
                        DestroyWindow( hWnd );
                        break;
              }
              break;
      
      case WM_DESTROY :
              PostQuitMessage(0);
              break;

      default :
            return( DefWindowProc( hWnd, uMsg, wParam, lParam ) );
   }

   return( 0L );
}


LRESULT CALLBACK TestDlgProc( HWND hDlg, UINT uMsg, 
                              WPARAM wParam, LPARAM lParam )
{
   switch( uMsg )
   {


      case WM_COMMAND :
            switch( LOWORD( wParam ) )
            {
               case IDOK: 
                    /* update global checkbox status variables */
                    status1 = SendDlgItemMessage(hDlg, IDD_CB1,
                       BM_GETCHECK, 0, 0);  // is box checked?
                    status2 = SendDlgItemMessage(hDlg, IDD_CB2,
                       BM_GETCHECK, 0, 0);  // is box checked?
                    EndDialog(hDlg, 0);
					break;
               case IDD_CB1: 
                    /* user selected 1st check box, so check it */
                    SendDlgItemMessage(hDlg, IDD_CB1, BM_SETCHECK, 1, 0);
					break;
               case IDCANCEL : 
                    EndDialog( hDlg, IDCANCEL );
                    break;
			   case IDD_RED:
                    MessageBox(hDlg, "You Picked Red", "RED", MB_OK);
                    break;
               case IDD_GREEN:
                    MessageBox(hDlg, "You Picked Green", "GREEN", MB_OK);
                    break;
			}
            break;

      default :
            return( FALSE );
   }

   return( TRUE );
}


LRESULT CALLBACK About( HWND hDlg,           
                        UINT message,        
                        WPARAM wParam,       
                        LPARAM lParam)
{
   switch (message) 
   {
       case WM_INITDIALOG: 
               return (TRUE);

      case WM_COMMAND:
      switch(LOWORD(wParam)) {
        case IDCANCEL:
          EndDialog(hDlg, 0);
          return 1;

          return 1;
      }
   }

   return (FALSE); 
}
