#include <windows.h>
#include <string.h>
#include <stdio.h>
#include "Viewport11.h"
#include "resource.h"


/* Set the mapping mode, the window and the viewport extents. */


#if defined (WIN32)
	#define IS_WIN32 TRUE
#else
	#define IS_WIN32 FALSE
#endif

#define IS_NT      IS_WIN32 && (BOOL)(GetVersion() < 0x80000000)
#define IS_WIN32S  IS_WIN32 && (BOOL)(!(IS_NT) && (LOBYTE(LOWORD(GetVersion()))<4))
#define IS_WIN95   (BOOL)(!(IS_NT) && !(IS_WIN32S)) && IS_WIN32

HINSTANCE hInst;   // current instance
BOOL RegisterWin95( CONST WNDCLASS* lpwc );

LPCTSTR lpszAppName  = "MyApp";
LPCTSTR lpszTitle    = "Viewport11  11 ";
char str[255]; /* holds output strings */

int X=0, Y=0; /* current output location */
int maxX, maxY; /* screen dimensions */


int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                      LPTSTR lpCmdLine, int nCmdShow)
{
   MSG      msg;
   HWND     hWnd; 
   WNDCLASS wc;

      // Register the main application window class.
   //............................................
   wc.style         = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc   = (WNDPROC)WndProc; /* window function */      
   wc.cbClsExtra    = 0;                      
   wc.cbWndExtra    = 0;                      
   wc.hInstance     = hInstance;  /* handle to this instance */            
   wc.hIcon         = LoadIcon( hInstance, lpszAppName ); /* icon style */
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);        /* cursor style */
   wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName  = lpszAppName;              
   wc.lpszClassName = lpszAppName; /* window class name */

   if ( IS_WIN95 )
   {
      if ( !RegisterWin95( &wc ) )
         return( FALSE );
   }
   else if ( !RegisterClass( &wc ) )
      return( FALSE );

    hInst = hInstance; 

   // Create the main application window.
   //....................................
   hWnd = CreateWindow( lpszAppName, 
                        lpszTitle,    
                        WS_OVERLAPPEDWINDOW, 
                        CW_USEDEFAULT, 0, 
                        CW_USEDEFAULT, 0,  
                        NULL,              
                        NULL,              
                        hInstance,         
                        NULL               
                      );

   if ( !hWnd ) 
      return( FALSE );

   ShowWindow( hWnd, nCmdShow ); 
   UpdateWindow( hWnd );         

   while( GetMessage( &msg, NULL, 0, 0) )   
   {
      TranslateMessage( &msg ); 
      DispatchMessage( &msg );  
   }

   return( msg.wParam ); 

}


BOOL RegisterWin95( CONST WNDCLASS* lpwc )
{
   WNDCLASSEX wcex;

   wcex.style         = lpwc->style;
   wcex.lpfnWndProc   = lpwc->lpfnWndProc;
   wcex.cbClsExtra    = lpwc->cbClsExtra;
   wcex.cbWndExtra    = lpwc->cbWndExtra;
   wcex.hInstance     = lpwc->hInstance;
   wcex.hIcon         = lpwc->hIcon;
   wcex.hCursor       = lpwc->hCursor;
   wcex.hbrBackground = lpwc->hbrBackground;
   wcex.lpszMenuName  = lpwc->lpszMenuName;
   wcex.lpszClassName = lpwc->lpszClassName;

   // Added elements for Windows 95.
   //...............................
   wcex.cbSize = sizeof(WNDCLASSEX);
   wcex.hIconSm = LoadIcon(wcex.hInstance, "SMALL");
			
   return RegisterClassEx( &wcex );
}


/* This function is called by Windows 95 and is passed 
   messages from the message queue.
*/
LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{  
   HDC hDC;
   PAINTSTRUCT paintstruct;
   static HPEN hRedpen, hGreenpen, hBluepen, hYellowpen, hOldpen;

   static HDC memdc; /* store the virtual device handle */
   static HBITMAP hBit; /* store the virtual bitmap */
   static HBRUSH hBrush, hOldbrush; /* store the brush handle */
   static int orgX = 0, orgY = 0;

   switch( uMsg )
   {
	  case WM_CREATE:
         maxX = GetSystemMetrics(SM_CXSCREEN);
         maxY = GetSystemMetrics(SM_CYSCREEN);

         /* make a compatible memory image device */
         hDC = GetDC(hWnd);
         memdc = CreateCompatibleDC(hDC);
         hBit = CreateCompatibleBitmap(hDC, maxX, maxY);
         SelectObject(memdc, hBit);
         hBrush = (HBRUSH)GetStockObject(WHITE_BRUSH);
         SelectObject(memdc, hBrush);
         PatBlt(memdc, 0, 0, maxX, maxY, PATCOPY);

         hRedpen = CreatePen(PS_SOLID, 1, RGB(255,0,0));
         hGreenpen = CreatePen(PS_SOLID, 2, RGB(0,255,0));
         hBluepen = CreatePen(PS_SOLID, 3, RGB(0,0,255));
         hYellowpen = CreatePen(PS_SOLID, 4, RGB(255, 255, 0));
         
		 /* save default pen */
         hOldpen = (HPEN)SelectObject(memdc, hRedpen);
         SelectObject(memdc, hOldpen);

         ReleaseDC(hWnd, hDC);
		 X = 40;
		 Y = 40;
         break;
      case WM_COMMAND :
              switch( LOWORD( wParam ) )
              {
			      case IDM_LINES: 
                     /* set 2 pixels */
                     SetPixel(memdc, 40, 14, RGB(0, 0, 0));
                     SetPixel(memdc, 40, 15, RGB(0, 0, 0));

                     LineTo(memdc, 100, 50);
                     MoveToEx(memdc, 100, 50, NULL);

                     /* change to green pen */
                     hOldpen = (HPEN)SelectObject(memdc, hGreenpen);
                     LineTo(memdc, 200, 100);

                     /* change to yellow pen */
                     SelectObject(memdc, hYellowpen);
                     LineTo(memdc, 0, 200); 
       
                     /* change to blue pen */
                     SelectObject(memdc, hBluepen);
                     LineTo(memdc, 200, 200); 

                     /* change to red pen */
                     SelectObject(memdc, hRedpen);
                     LineTo(memdc, 0, 0); 

                     /* return to default pen */
                     SelectObject(memdc, hOldpen);

                     Arc(memdc, 0, 0, 300, 300, 0, 50, 200, 50);
                     
					 /* show intersecting lines that define arc */
                     MoveToEx(memdc, 150, 150, NULL);
                     LineTo(memdc, 0, 50); 
                     MoveToEx(memdc, 150, 150, NULL);
                     LineTo(memdc, 200, 50); 

                     InvalidateRect(hWnd, NULL, 1);
                     break;
                  case IDM_RECTANGLES:  
                     /* display, but don't fill */
                     hOldbrush = (HBRUSH)SelectObject(memdc, 
						 GetStockObject(HOLLOW_BRUSH));

                     /* draw some rectangles */
                     Rectangle(memdc, 50, 50, 300, 300);
                     RoundRect(memdc, 125, 125, 220, 240, 15, 13);

                     /* use a red pen */
                     SelectObject(memdc, hRedpen);
                     Rectangle(memdc, 100, 100, 200, 200);
                     SelectObject(memdc, hOldpen); /* return to default pen */
  
                     /* restore default brush */
                     SelectObject(memdc, hOldbrush);

                     InvalidateRect(hWnd, NULL, 1);   
                     break;
                  case IDM_ELLIPSES:  
                     /* make blue brush */
                     hBrush = CreateSolidBrush(RGB(0, 0, 255));
                     hOldbrush = (HBRUSH)SelectObject(memdc, hBrush);

                     /* fill these ellipses with blue */
                     Ellipse(memdc, 50, 200, 100, 280);
                     Ellipse(memdc, 75, 25, 280, 100);

                     /* use a red pen and fill with green */
                     SelectObject(memdc, hRedpen);
                     DeleteObject(hBrush); /* delete brush */
          
					 /* create green brush */
                     hBrush = CreateSolidBrush(RGB(0, 255, 0));
                     SelectObject(memdc, hBrush); /* select green brush */
                     Ellipse(memdc, 100, 100, 200, 200);

                     /* draw a pie slice */
                     Pie(memdc, 200, 200, 340, 340, 225, 200, 200, 250);

                     SelectObject(memdc, hOldpen); /* return to default pen */
 	                 SelectObject(memdc, hOldbrush); /* select default brush */
                     DeleteObject(hBrush); /* delete green brush */
                     InvalidateRect(hWnd, NULL, 1);
                     break;
				  case IDM_SIZE:
					  X += 10;
					  Y += 10;
					  InvalidateRect(hWnd, NULL, 1);
					  break;
				 case IDM_ORG:
                    orgX += 50;
					orgY += 50;
					InvalidateRect(hWnd, NULL, 1);
                    break;
                 case IDM_RESET:
					 orgX = 0;
					 orgY = 0;
					 X = 40;
					 Y = 40;
				 case IDM_CLEAR:
                    /* reset current position to 0,0 */
                    MoveToEx(memdc, 0, 0, NULL);
          
					/* erase by repainting background */
                    PatBlt(memdc, 0, 0, maxX, maxY, PATCOPY);
                    InvalidateRect(hWnd, NULL, 1);
					break;
                 case IDM_ABOUT :
                        DialogBox( hInst, "AboutBox", hWnd, (DLGPROC)About );
                        break;

                 case IDM_EXIT :
                        DestroyWindow( hWnd );
                        break;
              }
              break;
      case WM_PAINT: /* process a repaint request */
           hDC = BeginPaint(hWnd, &paintstruct); /* get DC */

		   /* set mapping mode, window and viewport extents */
		   SetMapMode(hDC, MM_ANISOTROPIC);
		   SetWindowExtEx(hDC, 200, 200, NULL);
		   SetViewportExtEx(hDC, X, Y, NULL);
           SetViewportOrgEx(hDC, orgX, orgY, NULL);

           /* now, copy memory image onto screen */
           BitBlt(hDC, 0, 0, maxX, maxY, memdc, 0, 0, SRCCOPY);
           EndPaint(hWnd, &paintstruct); /* release DC */
           break;
      case WM_DESTROY :
	       DeleteDC(memdc); /* delete the memory device */
           PostQuitMessage(0);
           break;
      default :
            return( DefWindowProc( hWnd, uMsg, wParam, lParam ) );
   }

   return( 0L );
}

LRESULT CALLBACK About( HWND hDlg,           
                        UINT message,        
                        WPARAM wParam,       
                        LPARAM lParam)
{
   switch (message) 
   {
       case WM_INITDIALOG: 
               return (TRUE);

       case WM_COMMAND:                              
               if (   LOWORD(wParam) == IDOK         
                   || LOWORD(wParam) == IDCANCEL)    
               {
                       EndDialog(hDlg, TRUE);        
                       return (TRUE);
               }
               break;
   }

   return (FALSE); 
}
