#include <windows.h>
#include <commctrl.h>
#include "Status_bar.h"
#include <stdio.h>
#define IS_WIN32 TRUE

/* Demonstrate a status bar. */

#define NUMPARTS 3



HINSTANCE hInst;        // current instance

LPCTSTR lpszAppName = "StatusBar";
LPCTSTR lpszTitle =   "Using a Status Bar";

BOOL RegisterWin95(CONST WNDCLASS* lpwc);
int parts[NUMPARTS];

extern void InitStatus(HWND hWnd);
HWND hStatusWnd;

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
 {
   MSG msg;
   HWND hWnd;
   WNDCLASS wc;

   wc.style          = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc    = (WNDPROC)WndProc;
   wc.cbClsExtra     = 0;
   wc.cbWndExtra     = 0;
   wc.hInstance      = 0;
   wc.hIcon          = LoadIcon(hInstance, lpszAppName);
   wc.hCursor        = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground  = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName   = lpszAppName;
   wc.lpszClassName  = lpszAppName;

   if(!RegisterWin95(&wc))
      return false;
   hInst = hInstance;
   hWnd = CreateWindow (lpszAppName,
                        lpszTitle,
                        WS_OVERLAPPEDWINDOW,
                        CW_USEDEFAULT, 0,
                        CW_USEDEFAULT, 0,
                        NULL,
                        NULL,
                        hInstance,
                        NULL
                       );
   if(!hWnd)
      return false;
   InitCommonControls();
   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);
   while(GetMessage(&msg, NULL, 0,0))
    {
      TranslateMessage(&msg);
      DispatchMessage(&msg);
    }
   return(msg.wParam);
 }

BOOL RegisterWin95(CONST WNDCLASS* lpwc)
 {
   WNDCLASSEX wcex;

   wcex.style           = lpwc->style;
   wcex.lpfnWndProc     = lpwc->lpfnWndProc;
   wcex.cbClsExtra      = lpwc->cbClsExtra;
   wcex.cbWndExtra      = lpwc->cbWndExtra;
   wcex.hInstance       = lpwc->hInstance;
   wcex.hIcon           = lpwc->hIcon;
   wcex.hCursor         = lpwc->hCursor;
   wcex.hbrBackground   = lpwc->hbrBackground;
   wcex.lpszMenuName    = lpwc->lpszMenuName;
   wcex.lpszClassName   = lpwc->lpszClassName;
   wcex.cbSize          = sizeof(WNDCLASSEX);
   wcex.hIconSm         = LoadIcon(wcex.hInstance, "SMALL");
   return RegisterClassEx(&wcex);
 }

LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
 {
   switch(uMsg)
    {
      case WM_COMMAND:
         switch(LOWORD(wParam))
          {
            case IDM_TEST :
				DialogBox(hInst, "STATUSDLG", hWnd, (DLGPROC)DialogFunc);
               break;
            case IDM_EXIT :
               DestroyWindow(hWnd);
               break;
          }
         break;
      case WM_DESTROY :
         PostQuitMessage(0);
         break;
      default:
         return (DefWindowProc(hWnd, uMsg, wParam, lParam));
    }
   return(0L);
 }






/* A simple dialog function. */
LRESULT CALLBACK DialogFunc(HWND hDlg, UINT message,
                         WPARAM wParam, LPARAM lParam)
{
  static long udpos = 0;
  static char str[80];
  static HWND hEboxWnd;
  static HWND udWnd;
  static statusCB1, statusCB2;
  int low=0, high=20;

  switch(message) {
    case WM_INITDIALOG:
     InitStatus(hDlg); /* initialize the status bar */
     hEboxWnd = GetDlgItem(hDlg, ID_EB1);
     udWnd = CreateUpDownControl(
                   WS_CHILD | WS_BORDER | WS_VISIBLE |
                   UDS_SETBUDDYINT | UDS_ALIGNRIGHT,
                   10, 10, 50, 50,
                   hDlg,
                   ID_UPDOWN,
                   hInst,
                   hEboxWnd,
                   high, low, high/2);
 return (TRUE);
    case WM_VSCROLL: /* process up-down control */
      if(udWnd==(HWND)lParam) {
        udpos = GetDlgItemInt(hDlg, ID_EB1, NULL, 1);
        sprintf(str, "Up-down: %d", udpos);
        SendMessage(hStatusWnd, SB_SETTEXT,
                    (WPARAM) 0, (LPARAM) str);
      }
      return (TRUE);
    case WM_COMMAND:
      switch(LOWORD(wParam)) {
        case ID_CB1: /* process checkbox 1 */
          statusCB1 = SendDlgItemMessage(hDlg, ID_CB1,
                      BM_GETCHECK, 0, 0);
          if(statusCB1) sprintf(str, "Option 1 ON");
          else sprintf(str, "Option 1 OFF");
          SendMessage(hStatusWnd, SB_SETTEXT,
                    (WPARAM) 1, (LPARAM) str);
          return (TRUE);
       case ID_CB2: /* process checkbox 2 */
          statusCB2 = SendDlgItemMessage(hDlg, ID_CB2,
                      BM_GETCHECK, 0, 0);
          if(statusCB2) sprintf(str, "Option 2 ON");
          else sprintf(str, "Option 2 OFF");
          SendMessage(hStatusWnd, SB_SETTEXT,
                    (WPARAM) 2, (LPARAM) str);
          return (TRUE);
        case ID_RESET: /* reset options */
          SendMessage(udWnd, UDM_SETPOS, 0, (LPARAM) high /2);
          SendMessage(hStatusWnd, SB_SETTEXT, (WPARAM) 0,
              (LPARAM) "Up-down: 10");
          SendDlgItemMessage(hDlg, ID_CB1,
                      BM_SETCHECK, 0, 0);
          SendDlgItemMessage(hDlg, ID_CB2,
                      BM_SETCHECK, 0, 0);
          SendMessage(hStatusWnd, SB_SETTEXT, (WPARAM) 1,
              (LPARAM) "Option 1: OFF");
          SendMessage(hStatusWnd, SB_SETTEXT, (WPARAM) 2,
              (LPARAM) "Option 2: OFF");
          return (TRUE);
        case IDCANCEL:
        case IDOK:
          EndDialog(hDlg, 0);
          return (TRUE);
      }
  }
  return 0;
}
/* Initialize the status bar. */
void InitStatus(HWND hWnd)
{
  RECT WinDim;
  int i;

  GetClientRect(hWnd, &WinDim);

  for(i=1; i<=NUMPARTS; i++)
    parts[i-1] = WinDim.right/NUMPARTS * i;

  /* Create a status bar */
  hStatusWnd = CreateWindow(STATUSCLASSNAME,
               "", /* not used in this example */
               WS_CHILD | WS_VISIBLE,
               0, 0, 0, 0,
               hWnd,
               NULL,
               hInst,
               NULL
      );
  SendMessage(hStatusWnd, SB_SETPARTS,
              (WPARAM) NUMPARTS, (LPARAM) parts);

  SendMessage(hStatusWnd, SB_SETTEXT, (WPARAM) 0,
              (LPARAM) "Up-down: 10");
  SendMessage(hStatusWnd, SB_SETTEXT, (WPARAM) 1,
              (LPARAM) "Option 1: OFF");
  SendMessage(hStatusWnd, SB_SETTEXT, (WPARAM) 2,
              (LPARAM) "Option 2: OFF");
}