#include <windows.h>
#include <commctrl.h>
#include <stdio.h>

#include "TabControl.h"
#define IS_WIN32 TRUE


HINSTANCE hInst;        // current instance
HWND hWnd; 
HWND hTabWnd;
LPCTSTR lpszAppName = "Generic";
LPCTSTR lpszTitle =   "Generic Application";
BOOL RegisterWin95(CONST WNDCLASS* lpwc);


int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
 {
   TC_ITEM tci;
   MSG msg;
   WNDCLASS wc;
   RECT WinDim;

   wc.style          = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc    = (WNDPROC)WndProc;
   wc.cbClsExtra     = 0;
   wc.cbWndExtra     = 0;
   wc.hInstance      = 0;
   wc.hIcon          = LoadIcon(hInstance, lpszAppName);
   wc.hCursor        = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground  = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName   = lpszAppName;
   wc.lpszClassName  = lpszAppName;

   if(!RegisterWin95(&wc))
      return false;
   hInst = hInstance; /* save the current instance handle */

   hWnd = CreateWindow (lpszAppName,
                        lpszTitle,
                        WS_OVERLAPPEDWINDOW,
                        CW_USEDEFAULT, 0,
                        CW_USEDEFAULT, 0,
                        NULL,
                        NULL,
                        hInstance,
                        NULL
                       );


  GetClientRect(hWnd, &WinDim);  /* get size of parent window */
  InitCommonControls();

  /* create a tab control */
  hTabWnd = CreateWindow(
                  WC_TABCONTROL,
                  "",
                  WS_VISIBLE | WS_TABSTOP | WS_CHILD,
                  0, 0, WinDim.right, WinDim.bottom,
                  hWnd,
                  NULL,
                  hInst,
                  NULL
             );

  tci.mask = TCIF_TEXT;

  tci.iImage = -1;

  tci.pszText = "One";
  TabCtrl_InsertItem(hTabWnd, 0, &tci);
  tci.pszText = "Two";
  TabCtrl_InsertItem(hTabWnd, 1, &tci);

  tci.pszText = "Three";
  TabCtrl_InsertItem(hTabWnd, 2, &tci);

  /* Display the window. */
  ShowWindow(hWnd, nCmdShow);
  UpdateWindow(hWnd);

  /* Create the message loop. */
  while(GetMessage(&msg, NULL, 0, 0))
  {
    TranslateMessage(&msg); /* allow use of keyboard */
    DispatchMessage(&msg); /* return control to Windows */
  }
  return msg.wParam;
}


BOOL RegisterWin95(CONST WNDCLASS* lpwc)
 {
   WNDCLASSEX wcex;

   wcex.style           = lpwc->style;
   wcex.lpfnWndProc     = lpwc->lpfnWndProc;
   wcex.cbClsExtra      = lpwc->cbClsExtra;
   wcex.cbWndExtra      = lpwc->cbWndExtra;
   wcex.hInstance       = lpwc->hInstance;
   wcex.hIcon           = lpwc->hIcon;
   wcex.hCursor         = lpwc->hCursor;
   wcex.hbrBackground   = lpwc->hbrBackground;
   wcex.lpszMenuName    = lpwc->lpszMenuName;
   wcex.lpszClassName   = lpwc->lpszClassName;
   wcex.cbSize          = sizeof(WNDCLASSEX);
   wcex.hIconSm         = LoadIcon(wcex.hInstance, "SMALL");
   return RegisterClassEx(&wcex);
 }

LRESULT CALLBACK WndProc(HWND hWnd, UINT message,
                            WPARAM wParam, LPARAM lParam)
{
  NMHDR *nmptr;
  int tabnumber;
  HDC hdc;
  char str[80];
  switch(message) {
	case WM_COMMAND:
         switch(LOWORD(wParam))
          {
            case IDM_TEST :
               break;
            case IDM_EXIT :
               DestroyWindow(hWnd);
               break;
          }
         break;
	case WM_NOTIFY: /* process a tab change */
      nmptr = (LPNMHDR) lParam;
      if(nmptr->code == TCN_SELCHANGE) {
        tabnumber = TabCtrl_GetCurSel((HWND)nmptr->hwndFrom);
        hdc = GetDC(hTabWnd);
        sprintf(str, "Changed to Tab %d", tabnumber+1);
        SetBkColor(hdc, RGB(200, 200, 200));
        TextOut(hdc, 40, 100, str, strlen(str));
        ReleaseDC(hTabWnd, hdc);
      }
      break;
    case WM_DESTROY: /* terminate the program */
      PostQuitMessage(0);
      break;
    default:
     /* Let Windows 95 process any messages not specified in
        the preceding switch statement. */
    return DefWindowProc(hWnd, message, wParam, lParam);
  }
  return 0;
}

